Add sphinx extension
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Use bash in order to be able to use pipefail
13 SHELL=/bin/bash
14
15 ACLOCAL_AMFLAGS = -I autotools
16 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 CHECK_MAN = $(top_srcdir)/autotools/check-man
20 CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 REPLACE_VARS_SED = autotools/replace_vars.sed
23
24 clientdir = $(pkgpythondir)/client
25 hypervisordir = $(pkgpythondir)/hypervisor
26 httpdir = $(pkgpythondir)/http
27 masterddir = $(pkgpythondir)/masterd
28 confddir = $(pkgpythondir)/confd
29 rapidir = $(pkgpythondir)/rapi
30 serverdir = $(pkgpythondir)/server
31 watcherdir = $(pkgpythondir)/watcher
32 impexpddir = $(pkgpythondir)/impexpd
33 utilsdir = $(pkgpythondir)/utils
34 toolsdir = $(pkglibdir)/tools
35 docdir = $(datadir)/doc/$(PACKAGE)
36
37 # Delete output file if an error occurred while building it
38 .DELETE_ON_ERROR:
39
40 DIRS = \
41         autotools \
42         daemons \
43         devel \
44         doc \
45         doc/examples \
46         doc/examples/hooks \
47         doc/examples/gnt-debug \
48         lib \
49         lib/client \
50         lib/build \
51         lib/confd \
52         lib/http \
53         lib/hypervisor \
54         lib/impexpd \
55         lib/masterd \
56         lib/rapi \
57         lib/server \
58         lib/utils \
59         lib/watcher \
60         man \
61         qa \
62         test \
63         test/data \
64         tools
65
66 BUILDTIME_DIR_AUTOCREATE = \
67         scripts \
68         doc/api \
69         doc/coverage
70
71 BUILDTIME_DIRS = \
72         $(BUILDTIME_DIR_AUTOCREATE) \
73         doc/html
74
75 DIRCHECK_EXCLUDE = \
76         $(BUILDTIME_DIRS) \
77         ganeti-[0-9]*.[0-9]*.[0-9]* \
78         doc/html/_*
79
80 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
81
82 MAINTAINERCLEANFILES = \
83         $(docpng) \
84         $(maninput) \
85         doc/install-quick.rst \
86         doc/news.rst \
87         doc/upgrade.rst \
88         vcs-version
89
90 maintainer-clean-local:
91         rm -rf $(BUILDTIME_DIRS)
92
93 CLEANFILES = \
94         $(addsuffix /*.py[co],$(DIRS)) \
95         $(all_dirfiles) \
96         $(PYTHON_BOOTSTRAP) \
97         epydoc.conf \
98         autotools/replace_vars.sed \
99         daemons/daemon-util \
100         daemons/ensure-dirs \
101         daemons/ganeti-cleaner \
102         devel/upload \
103         doc/examples/bash_completion \
104         doc/examples/ganeti.initd \
105         doc/examples/ganeti-kvm-poweroff.initd \
106         doc/examples/ganeti.cron \
107         doc/examples/gnt-config-backup \
108         doc/examples/hooks/ipsec \
109         $(man_MANS) \
110         $(manhtml) \
111         tools/kvm-ifup \
112         stamp-srclinks \
113         $(nodist_pkgpython_PYTHON)
114
115 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
116 # it'll cause the target to rebuild every time.
117 BUILT_SOURCES = \
118         ganeti \
119         stamp-srclinks \
120         lib/_autoconf.py \
121         $(all_dirfiles) \
122         $(PYTHON_BOOTSTRAP)
123
124 nodist_pkgpython_PYTHON = \
125         lib/_autoconf.py
126
127 noinst_PYTHON = \
128         lib/build/__init__.py \
129         lib/build/sphinx_ext.py
130
131 pkgpython_PYTHON = \
132         lib/__init__.py \
133         lib/asyncnotifier.py \
134         lib/backend.py \
135         lib/bdev.py \
136         lib/bootstrap.py \
137         lib/cli.py \
138         lib/cmdlib.py \
139         lib/compat.py \
140         lib/config.py \
141         lib/constants.py \
142         lib/daemon.py \
143         lib/errors.py \
144         lib/ht.py \
145         lib/jqueue.py \
146         lib/jstore.py \
147         lib/locking.py \
148         lib/luxi.py \
149         lib/mcpu.py \
150         lib/netutils.py \
151         lib/objects.py \
152         lib/opcodes.py \
153         lib/qlang.py \
154         lib/query.py \
155         lib/rpc.py \
156         lib/runtime.py \
157         lib/serializer.py \
158         lib/ssconf.py \
159         lib/ssh.py \
160         lib/storage.py \
161         lib/uidpool.py \
162         lib/workerpool.py
163
164 client_PYTHON = \
165         lib/client/__init__.py \
166         lib/client/gnt_backup.py \
167         lib/client/gnt_cluster.py \
168         lib/client/gnt_debug.py \
169         lib/client/gnt_group.py \
170         lib/client/gnt_instance.py \
171         lib/client/gnt_job.py \
172         lib/client/gnt_node.py \
173         lib/client/gnt_os.py
174
175 hypervisor_PYTHON = \
176         lib/hypervisor/__init__.py \
177         lib/hypervisor/hv_base.py \
178         lib/hypervisor/hv_chroot.py \
179         lib/hypervisor/hv_fake.py \
180         lib/hypervisor/hv_kvm.py \
181         lib/hypervisor/hv_lxc.py \
182         lib/hypervisor/hv_xen.py
183
184 rapi_PYTHON = \
185         lib/rapi/__init__.py \
186         lib/rapi/baserlib.py \
187         lib/rapi/client.py \
188         lib/rapi/client_utils.py \
189         lib/rapi/connector.py \
190         lib/rapi/rlib2.py
191
192 http_PYTHON = \
193         lib/http/__init__.py \
194         lib/http/auth.py \
195         lib/http/client.py \
196         lib/http/server.py
197
198 confd_PYTHON = \
199         lib/confd/__init__.py \
200         lib/confd/client.py \
201         lib/confd/querylib.py \
202         lib/confd/server.py
203
204 masterd_PYTHON = \
205         lib/masterd/__init__.py \
206         lib/masterd/instance.py
207
208 impexpd_PYTHON = \
209         lib/impexpd/__init__.py
210
211 watcher_PYTHON = \
212         lib/watcher/__init__.py
213
214 server_PYTHON = \
215         lib/server/__init__.py \
216         lib/server/confd.py \
217         lib/server/masterd.py \
218         lib/server/noded.py \
219         lib/server/rapi.py
220
221 utils_PYTHON = \
222         lib/utils/__init__.py \
223         lib/utils/algo.py \
224         lib/utils/filelock.py \
225         lib/utils/hash.py \
226         lib/utils/io.py \
227         lib/utils/log.py \
228         lib/utils/mlock.py \
229         lib/utils/nodesetup.py \
230         lib/utils/process.py \
231         lib/utils/retry.py \
232         lib/utils/text.py \
233         lib/utils/wrapper.py \
234         lib/utils/x509.py
235
236 docrst = \
237         doc/admin.rst \
238         doc/design-2.0.rst \
239         doc/design-2.1.rst \
240         doc/design-2.2.rst \
241         doc/design-2.3.rst \
242         doc/design-2.4.rst \
243         doc/design-draft.rst \
244         doc/design-oob.rst \
245         doc/design-query2.rst \
246         doc/cluster-merge.rst \
247         doc/devnotes.rst \
248         doc/glossary.rst \
249         doc/hooks.rst \
250         doc/iallocator.rst \
251         doc/index.rst \
252         doc/install-quick.rst \
253         doc/install.rst \
254         doc/locking.rst \
255         doc/move-instance.rst \
256         doc/news.rst \
257         doc/rapi.rst \
258         doc/security.rst \
259         doc/upgrade.rst \
260         doc/walkthrough.rst
261
262 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
263
264 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
265         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/opdoc.py
266         @test -n "$(SPHINX)" || \
267             { echo 'sphinx-build' not found during configure; exit 1; }
268         @mkdir_p@ $(dir $@)
269         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
270             -d . \
271             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
272             -D release="$(PACKAGE_VERSION)" \
273             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
274         rm -f doc/html/.buildinfo doc/html/objects.inv
275         touch $@
276
277 doc/html: doc/html/index.html
278
279 doc/install-quick.rst: INSTALL
280 doc/news.rst: NEWS
281 doc/upgrade.rst: UPGRADE
282
283 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
284         set -e; \
285         { echo '.. This file is automatically updated at build time from $<.'; \
286           echo '.. Do not edit.'; \
287           echo; \
288           cat $<; \
289         } > $@
290
291 docdot = \
292         doc/arch-2.0.dot \
293         doc/design-2.1-lock-acquire.dot \
294         doc/design-2.1-lock-release.dot
295
296 docpng = $(patsubst %.dot,%.png,$(docdot))
297
298 # Things to build but not to install (add it to EXTRA_DIST if it should be
299 # distributed)
300 noinst_DATA = \
301         devel/upload \
302         doc/html \
303         doc/examples/bash_completion \
304         doc/examples/ganeti.cron \
305         doc/examples/ganeti.initd \
306         doc/examples/ganeti-kvm-poweroff.initd \
307         doc/examples/gnt-config-backup \
308         doc/examples/hooks/ipsec \
309         $(manhtml)
310
311 gnt_scripts = \
312         scripts/gnt-backup \
313         scripts/gnt-cluster \
314         scripts/gnt-debug \
315         scripts/gnt-group \
316         scripts/gnt-instance \
317         scripts/gnt-job \
318         scripts/gnt-node \
319         scripts/gnt-os
320
321 PYTHON_BOOTSTRAP = \
322         daemons/ganeti-confd \
323         daemons/ganeti-masterd \
324         daemons/ganeti-noded \
325         daemons/ganeti-watcher \
326         daemons/ganeti-rapi \
327         scripts/gnt-backup \
328         scripts/gnt-cluster \
329         scripts/gnt-debug \
330         scripts/gnt-group \
331         scripts/gnt-instance \
332         scripts/gnt-job \
333         scripts/gnt-node \
334         scripts/gnt-os
335
336 qa_scripts = \
337         qa/ganeti-qa.py \
338         qa/qa_cluster.py \
339         qa/qa_config.py \
340         qa/qa_daemon.py \
341         qa/qa_env.py \
342         qa/qa_error.py \
343         qa/qa_instance.py \
344         qa/qa_node.py \
345         qa/qa_os.py \
346         qa/qa_rapi.py \
347         qa/qa_tags.py \
348         qa/qa_utils.py
349
350 dist_sbin_SCRIPTS = \
351         tools/ganeti-listrunner
352
353 nodist_sbin_SCRIPTS = \
354         $(PYTHON_BOOTSTRAP) \
355         daemons/ganeti-cleaner
356
357 dist_tools_SCRIPTS = \
358         tools/burnin \
359         tools/cfgshell \
360         tools/cfgupgrade \
361         tools/cfgupgrade12 \
362         tools/cluster-merge \
363         tools/lvmstrap \
364         tools/move-instance \
365         tools/setup-ssh \
366         tools/sanitize-config
367
368 pkglib_python_scripts = \
369         daemons/import-export \
370         tools/check-cert-expired
371
372 pkglib_SCRIPTS = \
373         daemons/daemon-util \
374         daemons/ensure-dirs \
375         tools/kvm-ifup \
376         $(pkglib_python_scripts)
377
378 EXTRA_DIST = \
379         NEWS \
380         UPGRADE \
381         epydoc.conf.in \
382         pylintrc \
383         autotools/build-bash-completion \
384         autotools/check-python-code \
385         autotools/check-man \
386         autotools/check-news \
387         autotools/check-tar \
388         autotools/check-version \
389         autotools/gen-coverage \
390         autotools/testrunner \
391         $(RUN_IN_TEMPDIR) \
392         daemons/daemon-util.in \
393         daemons/ensure-dirs.in \
394         daemons/ganeti-cleaner.in \
395         $(pkglib_python_scripts) \
396         devel/upload.in \
397         tools/kvm-ifup.in \
398         $(docdot) \
399         $(docpng) \
400         $(docrst) \
401         doc/conf.py \
402         doc/html \
403         doc/examples/ganeti.initd.in \
404         doc/examples/ganeti-kvm-poweroff.initd.in \
405         doc/examples/ganeti.cron.in \
406         doc/examples/gnt-config-backup.in \
407         doc/examples/ganeti.default \
408         doc/examples/ganeti.default-debug \
409         doc/examples/hooks/ethers \
410         doc/examples/hooks/ipsec.in \
411         doc/examples/gnt-debug/README \
412         doc/examples/gnt-debug/delay0.json \
413         doc/examples/gnt-debug/delay50.json \
414         test/testutils.py \
415         test/mocks.py \
416         $(dist_TESTS) \
417         $(TEST_FILES) \
418         man/footer.rst \
419         $(manrst) \
420         $(maninput) \
421         qa/qa-sample.json \
422         $(qa_scripts)
423
424 man_MANS = \
425         man/ganeti.7 \
426         man/ganeti-cleaner.8 \
427         man/ganeti-confd.8 \
428         man/ganeti-listrunner.8 \
429         man/ganeti-masterd.8 \
430         man/ganeti-noded.8 \
431         man/ganeti-os-interface.7 \
432         man/ganeti-rapi.8 \
433         man/ganeti-watcher.8 \
434         man/gnt-backup.8 \
435         man/gnt-cluster.8 \
436         man/gnt-debug.8 \
437         man/gnt-group.8 \
438         man/gnt-instance.8 \
439         man/gnt-job.8 \
440         man/gnt-node.8 \
441         man/gnt-os.8
442
443 manrst = $(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS)))
444 manhtml = $(patsubst %.rst,%.html,$(manrst))
445 maninput = \
446         $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) \
447         $(patsubst %.html,%.html.in,$(manhtml)) \
448         man/footer.man man/footer.html
449
450 TEST_FILES = \
451         test/data/bdev-drbd-8.0.txt \
452         test/data/bdev-drbd-8.3.txt \
453         test/data/bdev-drbd-disk.txt \
454         test/data/bdev-drbd-net-ip4.txt \
455         test/data/bdev-drbd-net-ip6.txt \
456         test/data/cert1.pem \
457         test/data/proc_drbd8.txt \
458         test/data/proc_drbd80-emptyline.txt \
459         test/data/proc_drbd83.txt \
460         test/data/sys_drbd_usermode_helper.txt \
461         test/import-export_unittest-helper
462
463 python_tests = \
464         test/ganeti.asyncnotifier_unittest.py \
465         test/ganeti.backend_unittest.py \
466         test/ganeti.bdev_unittest.py \
467         test/ganeti.cli_unittest.py \
468         test/ganeti.client.gnt_instance_unittest.py \
469         test/ganeti.daemon_unittest.py \
470         test/ganeti.cmdlib_unittest.py \
471         test/ganeti.compat_unittest.py \
472         test/ganeti.confd.client_unittest.py \
473         test/ganeti.config_unittest.py \
474         test/ganeti.constants_unittest.py \
475         test/ganeti.errors_unittest.py \
476         test/ganeti.hooks_unittest.py \
477         test/ganeti.ht_unittest.py \
478         test/ganeti.http_unittest.py \
479         test/ganeti.hypervisor_unittest.py \
480         test/ganeti.hypervisor.hv_chroot_unittest.py \
481         test/ganeti.hypervisor.hv_fake_unittest.py \
482         test/ganeti.hypervisor.hv_kvm_unittest.py \
483         test/ganeti.hypervisor.hv_lxc_unittest.py \
484         test/ganeti.hypervisor.hv_xen_unittest.py \
485         test/ganeti.impexpd_unittest.py \
486         test/ganeti.jqueue_unittest.py \
487         test/ganeti.locking_unittest.py \
488         test/ganeti.luxi_unittest.py \
489         test/ganeti.masterd.instance_unittest.py \
490         test/ganeti.mcpu_unittest.py \
491         test/ganeti.netutils_unittest.py \
492         test/ganeti.objects_unittest.py \
493         test/ganeti.opcodes_unittest.py \
494         test/ganeti.qlang_unittest.py \
495         test/ganeti.query_unittest.py \
496         test/ganeti.rapi.baserlib_unittest.py \
497         test/ganeti.rapi.client_unittest.py \
498         test/ganeti.rapi.resources_unittest.py \
499         test/ganeti.rapi.rlib2_unittest.py \
500         test/ganeti.rpc_unittest.py \
501         test/ganeti.runtime_unittest.py \
502         test/ganeti.serializer_unittest.py \
503         test/ganeti.ssh_unittest.py \
504         test/ganeti.uidpool_unittest.py \
505         test/ganeti.utils.algo_unittest.py \
506         test/ganeti.utils.filelock_unittest.py \
507         test/ganeti.utils.hash_unittest.py \
508         test/ganeti.utils.io_unittest.py \
509         test/ganeti.utils.mlock_unittest.py \
510         test/ganeti.utils.nodesetup_unittest.py \
511         test/ganeti.utils.process_unittest.py \
512         test/ganeti.utils.retry_unittest.py \
513         test/ganeti.utils.text_unittest.py \
514         test/ganeti.utils.wrapper_unittest.py \
515         test/ganeti.utils.x509_unittest.py \
516         test/ganeti.utils_unittest.py \
517         test/ganeti.workerpool_unittest.py \
518         test/cfgupgrade_unittest.py \
519         test/docs_unittest.py \
520         test/tempfile_fork_unittest.py
521
522 dist_TESTS = \
523         test/check-cert-expired_unittest.bash \
524         test/daemon-util_unittest.bash \
525         test/ganeti-cleaner_unittest.bash \
526         test/import-export_unittest.bash \
527         $(python_tests)
528
529 nodist_TESTS =
530
531 TESTS = $(dist_TESTS) $(nodist_TESTS)
532
533 # Environment for all tests
534 PLAIN_TESTS_ENVIRONMENT = \
535         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
536
537 # Environment for tests run by automake
538 TESTS_ENVIRONMENT = \
539         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
540
541 all_python_code = \
542         $(dist_sbin_SCRIPTS) \
543         $(dist_tools_SCRIPTS) \
544         $(pkglib_python_scripts) \
545         $(python_tests) \
546         $(pkgpython_PYTHON) \
547         $(client_PYTHON) \
548         $(hypervisor_PYTHON) \
549         $(rapi_PYTHON) \
550         $(server_PYTHON) \
551         $(http_PYTHON) \
552         $(confd_PYTHON) \
553         $(masterd_PYTHON) \
554         $(impexpd_PYTHON) \
555         $(utils_PYTHON) \
556         $(watcher_PYTHON) \
557         $(noinst_PYTHON) \
558         $(qa_scripts)
559
560 srclink_files = \
561         man/footer.rst \
562         test/check-cert-expired_unittest.bash \
563         test/daemon-util_unittest.bash \
564         test/ganeti-cleaner_unittest.bash \
565         test/import-export_unittest.bash \
566         $(all_python_code)
567
568 check_python_code = \
569         $(BUILD_BASH_COMPLETION) \
570         $(all_python_code)
571
572 lint_python_code = \
573         ganeti \
574         ganeti/http/server.py \
575         $(dist_sbin_SCRIPTS) \
576         $(dist_tools_SCRIPTS) \
577         $(pkglib_python_scripts) \
578         $(BUILD_BASH_COMPLETION) \
579         $(PYTHON_BOOTSTRAP)
580
581 test/daemon-util_unittest.bash: daemons/daemon-util
582
583 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
584
585 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
586         sed -f $(REPLACE_VARS_SED) < $< > $@
587         chmod +x $@
588
589 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
590         sed -f $(REPLACE_VARS_SED) < $< > $@
591         chmod u+x $@
592
593 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
594         sed -f $(REPLACE_VARS_SED) < $< > $@
595         chmod +x $@
596
597 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
598         sed -f $(REPLACE_VARS_SED) < $< > $@
599
600 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
601         sed -f $(REPLACE_VARS_SED) < $< > $@
602
603 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
604         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
605         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
606
607 doc/%.png: doc/%.dot
608         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
609         $(DOT) -Tpng -o $@ $<
610
611 man/footer.man: man/footer.rst
612         @test -n "$(PANDOC)" || \
613           { echo 'pandoc' not found during configure; exit 1; }
614         $(PANDOC) -f rst -t man -o $@ $<
615
616 man/footer.html: man/footer.rst
617         @test -n "$(PANDOC)" || \
618           { echo 'pandoc' not found during configure; exit 1; }
619         $(PANDOC) -f rst -t html -o $@ $<
620
621 man/%.7.in man/%.8.in: man/%.rst man/footer.man
622         @test -n "$(PANDOC)" || \
623           { echo 'pandoc' not found during configure; exit 1; }
624         set -o pipefail ; \
625         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
626           sed -e 's/\\@/@/g' > $@
627         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
628
629 man/%.html.in: man/%.rst man/footer.html
630         @test -n "$(PANDOC)" || \
631           { echo 'pandoc' not found during configure; exit 1; }
632         set -o pipefail ; \
633         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
634           sed -e 's/\\@/@/g' > $@
635
636 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
637         sed -f $(REPLACE_VARS_SED) < $< > $@
638
639 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
640         sed -f $(REPLACE_VARS_SED) < $< > $@
641
642 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
643         sed -f $(REPLACE_VARS_SED) < $< > $@
644
645 epydoc.conf: epydoc.conf.in
646         sed -e 's#@MODULES@#$(lint_python_code)#g' < $< > $@
647
648 vcs-version:
649         if test -d .git; then \
650           git describe > $@; \
651         elif test ! -f $@ ; then \
652           echo "Cannot auto-generate $@ file"; exit 1; \
653         fi
654
655 .PHONY: regen-vcs-version
656 regen-vcs-version:
657         set -e; \
658         cd $(srcdir); \
659         if test -d .git; then \
660           rm -f vcs-version; \
661           $(MAKE) vcs-version; \
662         fi
663
664 lib/_autoconf.py: Makefile vcs-version | lib/.dir
665         set -e; \
666         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
667         { echo '# This file is automatically generated, do not edit!'; \
668           echo '#'; \
669           echo ''; \
670           echo '"""Build-time configuration for Ganeti.'; \
671           echo '';\
672           echo 'This file is autogenerated by the build process.'; \
673           echo 'For any changes you need to re-run ./configure (and'; \
674           echo 'not edit by hand).'; \
675           echo ''; \
676           echo '"""'; \
677           echo ''; \
678           echo '# pylint: disable-msg=C0301,C0324'; \
679           echo '# because this is autogenerated, we do not want'; \
680           echo '# style warnings' ; \
681           echo ''; \
682           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
683           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
684           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
685           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
686           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
687           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
688           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
689           echo "SYSCONFDIR = '$(sysconfdir)'"; \
690           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
691           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
692           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
693           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
694           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
695           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
696           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
697           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
698           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
699           echo "KVM_PATH = '$(KVM_PATH)'"; \
700           echo "SOCAT_PATH = '$(SOCAT)'"; \
701           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
702           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
703           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
704           echo "TOOLSDIR = '$(toolsdir)'"; \
705           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
706           echo "PKGLIBDIR = '$(pkglibdir)'"; \
707           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
708           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
709           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
710           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
711           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
712           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
713           echo "RAPI_USER = '$(RAPI_USER)'"; \
714           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
715           echo "CONFD_USER = '$(CONFD_USER)'"; \
716           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
717           echo "NODED_USER = '$(NODED_USER)'"; \
718           echo "VCS_VERSION = '$$VCSVER'"; \
719           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
720         } > $@
721
722 $(REPLACE_VARS_SED): Makefile
723         set -e; \
724         { echo 's#@PREFIX@#$(prefix)#g'; \
725           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
726           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
727           echo 's#@BINDIR@#$(bindir)#g'; \
728           echo 's#@SBINDIR@#$(sbindir)#g'; \
729           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
730           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
731           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
732           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
733           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
734           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
735           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
736           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
737           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
738           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
739           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
740           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
741           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
742           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
743           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
744           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
745           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
746           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
747         } > $@
748
749 # Using deferred evaluation
750 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
751 daemons/ganeti-watcher: MODULE = ganeti.watcher
752 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
753
754 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
755         test -n "$(MODULE)" || { echo Missing module; exit 1; }
756         set -e; \
757         { echo '#!/usr/bin/python'; \
758           echo '# This file is automatically generated, do not edit!'; \
759           echo "# Edit $(MODULE) instead."; \
760           echo; \
761           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
762           echo; \
763           echo '# pylint: disable-msg=C0103'; \
764           echo '# C0103: Invalid name'; \
765           echo; \
766           echo 'import sys'; \
767           echo 'import $(MODULE) as main'; \
768           echo; \
769           echo '# Temporarily alias commands until bash completion'; \
770           echo '# generator is changed'; \
771           echo 'if hasattr(main, "commands"):'; \
772                 echo '  commands = main.commands # pylint: disable-msg=E1101'; \
773           echo; \
774           echo 'if __name__ == "__main__":'; \
775           echo '  sys.exit(main.Main())'; \
776         } > $@
777         chmod u+x $@
778
779 # We need to create symlinks because "make distcheck" will not install Python
780 # files when building.
781 stamp-srclinks: Makefile | $(all_dirfiles)
782         set -e; \
783         for i in $(srclink_files); do \
784                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
785                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
786                 fi; \
787         done
788         touch $@
789
790 .PHONY: ganeti
791 ganeti:
792         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
793
794 .PHONY: check-dirs
795 check-dirs: $(BUILT_SOURCES)
796         @set -e; \
797         find . -type d \( \( -name . \) -o \( \
798                 -name .git -o \
799                 -name autom4te.cache \
800                 \) -prune -o -print \) | { \
801                 error=; \
802                 while read dir; do \
803                         case "$$dir" in \
804                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
805                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
806                         esac; \
807                 done; \
808                 for dir in $(DIRS); do \
809                         if ! test -d "$$dir"; then \
810                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
811                                 error=1; \
812                         fi \
813                 done; \
814                 if test -n "$$error"; then exit 1; else exit 0; fi; \
815         }
816
817 check-local: check-dirs
818         $(CHECK_PYTHON_CODE) $(check_python_code)
819         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
820         $(CHECK_NEWS) < $(top_srcdir)/NEWS
821
822 .PHONY: lint
823 lint: $(BUILT_SOURCES)
824         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
825         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
826         cd $(top_srcdir)/qa && \
827           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
828           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
829
830 # a dist hook rule for updating the vcs-version file; this is
831 # hardcoded due to where it needs to build the file...
832 dist-hook:
833         $(MAKE) regen-vcs-version && \
834         rm -f $(top_distdir)/vcs-version && \
835         cp -p $(srcdir)/vcs-version $(top_distdir)
836
837 # a distcheck hook rule for catching revision control directories
838 distcheck-hook:
839         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
840                 echo "Found revision control files in final archive." 1>&2; \
841                 exit 1; \
842         fi
843         if find $(top_distdir) -name '*.py[co]' | grep .; then \
844                 echo "Found Python byte code in final archive." 1>&2; \
845                 exit 1; \
846         fi
847         if find $(top_distdir) -name '*~' | grep .; then \
848                 echo "Found backup files in final archive." 1>&2; \
849                 exit 1; \
850         fi
851 # Empty files or directories should not be distributed. They can cause
852 # unnecessary warnings for packagers. Directories used by automake during
853 # distcheck must be excluded.
854         if find $(top_distdir) -empty -and -not \( \
855                         -path $(top_distdir)/_build -or \
856                         -path $(top_distdir)/_inst \) | grep .; then \
857                 echo "Found empty files or directories in final archive." 1>&2; \
858                 exit 1; \
859         fi
860         if test -n "$(BUILD_RELEASE)" && \
861            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
862                 echo "Found unreleased version in NEWS." >&2; \
863                 exit 1; \
864         fi
865
866 # When building a release, stricter checks should be used
867 distcheck-release dist-release: export BUILD_RELEASE = 1
868 distcheck-release: distcheck
869
870 dist-release: dist
871         set -e; \
872         for i in $(DIST_ARCHIVES); do \
873                 echo -n "Checking $$i ... "; \
874                 autotools/check-tar < $$i; \
875                 echo OK; \
876         done
877
878 install-exec-local:
879         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
880           "$(DESTDIR)${localstatedir}/log/ganeti" \
881           "$(DESTDIR)${localstatedir}/run/ganeti"
882
883 # To avoid conflicts between directory names and other targets, a file inside
884 # the directory is used to ensure its existence.
885 %.dir:
886         @mkdir_p@ $* && touch $@
887
888 .PHONY: apidoc
889 apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
890         $(RUN_IN_TEMPDIR) epydoc -v \
891                 --conf $(CURDIR)/epydoc.conf \
892                 --output $(CURDIR)/doc/api
893
894 .PHONY: TAGS
895 TAGS: $(BUILT_SOURCES)
896         rm -f TAGS
897         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
898           -path './daemons/ganeti-*' -o -path './tools/*' -o \
899           -path './qa/*.py' | \
900           etags -l python -
901
902 .PHONY: coverage
903 coverage: $(BUILT_SOURCES) $(python_tests)
904         set -e; \
905         COVERAGE_FILE=$(CURDIR)/doc/coverage/data \
906         TEXT_COVERAGE=$(CURDIR)/doc/coverage/report.txt \
907         HTML_COVERAGE=$(CURDIR)/doc/coverage \
908         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
909         $(python_tests)
910
911 commit-check: distcheck lint apidoc
912
913 -include ./Makefile.local
914
915 # vim: set noet :